import java.util.LinkedList;
import java.util.ListIterator;

public class OpenTable<K, V> implements Table<K, V> {
	private LinkedList<Pair<K, V>>[] contents;
	private int size;
	@SuppressWarnings("unchecked")
	public OpenTable(int size) {
		this.size = size;
		contents = new LinkedList [size];
		for(int i = 0; i < size; i++) {
			contents[i] = new LinkedList<Pair<K, V>>();
		}
	}
	public V get(K k) {
		LinkedList<Pair<K, V>> lst = contents[k.hashCode() % size];
		ListIterator<Pair<K, V>> iter = lst.listIterator();
		for(; iter.hasNext(); ) {
			Pair<K, V> elem = iter.next(); 
			if (elem.fst.equals(k)) return elem.snd;
		}
		return null;
	}
	public boolean put(K k, V v) {
		LinkedList<Pair<K, V>> lst = contents[k.hashCode() % size];
		lst.addFirst(new Pair<K, V>(k, v));
		return true;
	}
	public void remove(K k) {
		LinkedList<Pair<K, V>> lst = contents[k.hashCode() % size];
		ListIterator<Pair<K, V>> iter = lst.listIterator();
		for(; iter.hasNext(); ) {
			Pair<K, V> elem = iter.next(); 
			if (elem.fst.equals(k)) {
				iter.remove();
				return;
			}
		}
	}
 
}